﻿using System.Collections.ObjectModel;
using System.ComponentModel;

namespace WpfTestingSample.Model
{
    public class DataItem : INotifyPropertyChanged
    {

        private string itemname;
        public string ItemName
        {
            get { return itemname; }

            set
            {
                itemname = value;
                OnPropertyChanged("ItemName");
            }
        }

        private string itemshortname;
        public string ItemShortName
        {
            get
            {
                return itemshortname;
            }
            set
            {
                itemshortname = value;
                OnPropertyChanged("ItemShortName");
            }
        }

        private int itemtype;
        public int ItemType
        {
            get
            {
                return itemtype;
            }
            set
            {
                itemtype = value;
                OnPropertyChanged("ItemType");
            }
        }

        private double? _value;
        public double? Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
                OnPropertyChanged("Value");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class DataItemDetails : ObservableCollection<DataItem>
    {
        public DataItemDetails()
        {
            PopulateCollection();
        }

        private void PopulateCollection()
        {
            Clear();
            Add(new DataItem { ItemName = "Testitem01", ItemShortName = "Test01", ItemType = 1 });
            Add(new DataItem { ItemName = "Testitem02", ItemShortName = "Test02", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem03", ItemShortName = "Test03", ItemType = 3 , Value = 12.12 });
            Add(new DataItem { ItemName = "Testitem04", ItemShortName = "Test04", ItemType = 3 , Value = 13.12});
            Add(new DataItem { ItemName = "Testitem05", ItemShortName = "Test05", ItemType = 3, Value = 34.345 });
            Add(new DataItem { ItemName = "Testitem06", ItemShortName = "Test06", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem07", ItemShortName = "Test07", ItemType = 1 });
            Add(new DataItem { ItemName = "Testitem08", ItemShortName = "Test08", ItemType = 1 });
            Add(new DataItem { ItemName = "Testitem09", ItemShortName = "Test09", ItemType = 1 });
            Add(new DataItem { ItemName = "Testitem10", ItemShortName = "Test10", ItemType = 1 });
            Add(new DataItem { ItemName = "Testitem11", ItemShortName = "Test11", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem12", ItemShortName = "Test12", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem13", ItemShortName = "Test13", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem14", ItemShortName = "Test14", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem15", ItemShortName = "Test15", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem16", ItemShortName = "Test16", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem17", ItemShortName = "Test17", ItemType = 2 });
            Add(new DataItem { ItemName = "Testitem18", ItemShortName = "Test18", ItemType = 1 });
            Add(new DataItem { ItemName = "Testitem19", ItemShortName = "Test19", ItemType = 1 });
            Add(new DataItem { ItemName = "Testitem20", ItemShortName = "Test20", ItemType = 1 });
        }
    }
}
